package com.elab.mq.msg;/**
 * Created by liukx on 2018/4/11.
 */

import com.elab.mq.api.ConsumeContext;
import com.elab.mq.model.MessageModel;

/**
 * 消费者业务监听模式
 *
 * @author Liukx
 * @create 2018-04-11 14:59
 * @email liukx@elab-plus.com
 **/
public interface IConsumeProcessService {

    /**
     * 业务方关注的Tag标识
     *
     * @return
     */
    String tag();

    /**
     * 根据上面的tag方法匹配后,具体执行的业务操作
     *
     * @param messageModel   消息内容
     * @param consumeContext 消费者上下文
     * @return
     * @throws Exception
     */
    boolean process(MessageModel messageModel, ConsumeContext consumeContext) throws Exception;


}
