package com.elab.mq.msg.impl;

import com.aliyun.openservices.ons.api.SendResult;
import com.aliyun.openservices.ons.api.impl.rocketmq.TransactionProducerImpl;
import com.aliyun.openservices.shade.com.alibaba.rocketmq.client.producer.TransactionCheckListener;
import com.elab.mq.model.MessageModel;
import com.elab.mq.model.SendResultModel;
import com.elab.mq.msg.IMsgTransactionFacade;
import com.elab.mq.msg.adptor.LocalTransactionExecuterAdaptor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Properties;

/**
 * 事务消息实现
 *
 * @author Liukx
 * @create 2018-04-09 18:33
 * @email liukx@elab-plus.com
 **/
//@Service
public class MsgTransactionImpl extends TransactionProducerImpl implements IMsgTransactionFacade {

    private Logger logger = LoggerFactory.getLogger(MsgTransactionImpl.class);

    public MsgTransactionImpl(Properties properties, TransactionCheckListener transactionCheckListener) {
        super(properties, transactionCheckListener);
    }


    @Override
    public SendResultModel send(MessageModel messageModel, LocalTransactionExecuterAdaptor executer, Object obj) {
        logger.info("执行一条事务消息 [" + messageModel.getMsgID() + "]: " + messageModel.toString() + " 执行器 : " + executer.getClass() + " 对象 ；" + obj.toString());
        SendResult send = super.send(messageModel, executer, obj);
        logger.info("事务消息执行结束 [" + messageModel + "]: ");
        return new SendResultModel(send);
    }
}
